<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>JavaScript Arrays</title>
</head>

<body>
    <script>
        let myArr = [];
        myArr.push(11);
        myArr.push(13);
        myArr[5] = 99;
        let theLastElement = myArr.pop(); // töötab nagu stack.
        console.log(myArr);

        let names = ['Mari', 'Malle', 'Kristo', 'Kalle', 'Bruno', 'Tambet'];
        let persons = [
            { name: 'Peeter', age: 28 },
            { name: 'Lauri', age: 21 },
            { name: 'Liina', age: 24 }
        ];


        // Kasulikud massiivimeetodid

        // 1) .find() - leiab esimese elemendi, mis vastab antud tingimusele
        let result = names.find(n => n === 'Malle');
        console.log('Otsi Mallet', result);
        result = names.find(n => n.toLowerCase().startsWith('b'));
        console.log('Otsi B-tähega algavat sõna', result);
        // Leia esimene inimene, kes on alla 25 aasta vana:
        let veryYoungAdult = persons.find(p => p.age < 25);
        console.log('Esimene leitud alla 25-aastane inimene', veryYoungAdult);

        // 2) .filter() - leiab kõik tingimusele vastavad elemendid massiivist (tagastab alammassiivi)
        // Leia kõik alla 25 aasta vanad inimesed:
        let youngAdults = persons.filter(person => person.age < 25);
        console.log('Leitud noored täiskasvanud', youngAdults);

        // 3) .map() - konverteerib kõik massiivi elemendid ühelt kujult teisele kindla reegli järgi
        let personStrings = persons.map(p => p.name + ' on ' + p.age + ' aastat vana!');
        console.log(personStrings);

        // 4) .some() - küsime massiivilt, kas mõni (vähemalt üks) element vastab etteantud tingimusele
        // Kas persons massiivis on mõni alla 25 aasta vanune inimene?
        let youngAdultsExist = persons.some(p => p.age < 25);
        console.log('Kas on noori täiskasvanuid', youngAdultsExist);

        // 5) .every() - küsime massiivilt, kas kõik elemendid vastavad tingimusele
        // Kas massiivis on kõik täisealised?
        let allAreAdults = persons.every(p => p.age >= 18);
        console.log('Kas kõik on täisealised?', allAreAdults);

        // 6) .forEach() - käib läbi kõik massiivi elemendid ja teeb nendega midagi.
        // Natuke .map() meetodi sarnane, aga erinevalt map()-ist ei tagasta midagi.
        persons.forEach(person => {
            console.log('---');
            console.log('Persoon: ');
            console.log('Eesnimi: ' + person.name);
            console.log('Vanus: ' + person.age);
        });

        // 7) .reduce() - arvutab agregeeritud väärtuse massiivielementide baasil
        let numbers = [1, 2, 3];
        // Kui palju on massiivi elementide kogusumma?
        let numbersSum = numbers.reduce( 
                (currentTotal, currentNumber) => { return currentTotal + currentNumber }, // Param 1: agregaatfunktsioon
                0 // Param 2: algne summa
            );
        console.log('Massiivi numbrite kogusumma: ' + numbersSum);

    </script>
</body>

</html>